package fr.unice.reneviergonin.demomulti;

import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.util.AttributeSet;
import android.util.Log;
import android.view.MotionEvent;
import android.view.View;

import java.util.ArrayList;

import fr.unice.reneviergonin.demomulti.images.MyPolygon;

/**
 * Created by renevier-gonin on 10/10/2014.
 */
public class MyView extends View {

    MyPolygon current ;
    MyPolygon last ;
    Paint paint = new Paint();
    {
        paint.setStrokeWidth(3f);
        paint.setFlags(Paint.ANTI_ALIAS_FLAG);
    }
    ArrayList<Integer> knownIds ;

    public MyView(Context context, AttributeSet attrs) {
        super(context, attrs);
    }

    public MyView(Context context, AttributeSet attrs, int defStyleAttr) {
        super(context, attrs, defStyleAttr);
    }

    public MyView(Context context) {
        super(context);
    }


    // boolean pour ne pas "flooder" avec des move (action == 2)
    boolean lastwas2 = false;
    @Override
    public boolean onTouchEvent(MotionEvent e) {
        // pour afficher les évenements dans la console, sans "flooder" avec des move (action == 2)
        if (e.getActionMasked() != 2) {
            Log.d("touch = ", " mask = " + e.getActionMasked() + " || pointer = "+e.getActionIndex() + " || pointer = "+e.getPointerId(e.getActionIndex()));
            lastwas2 = false;
        }
        else {
            if (! lastwas2) {
                Log.d("touch = ", " mask = " + e.getActionMasked() + " || pointer = "+e.getActionIndex()+ " || pointer = "+e.getPointerId(e.getActionIndex()));
                lastwas2 = true;
            }
        }

        /* interpretation... */
        /***** le polygone en cours de dessin *****/
        if (e.getActionMasked() == MotionEvent.ACTION_MOVE) {

            if (current == null) {
                current = new MyPolygon();
                knownIds = new ArrayList<Integer>();
            }

            int id = e.getPointerId(e.getPointerCount()-1);

            boolean inside = false;

            /*
            for(Integer i : knownIds) {
                if (i.intValue() == id)
                {
                    inside = true;
                    break;
                }
            }
            */

            if (! inside) {
                MotionEvent.PointerCoords point = new MotionEvent.PointerCoords();
                e.getPointerCoords(e.getPointerCount()-1, point);
                current.addPoint(point.x, point.y);
                knownIds.add(id);
            }


        }
        else  if ((e.getActionMasked() == MotionEvent.ACTION_UP) && (e.getPointerCount() == 1) && (current != null)) { // le dernier doigt est levé
                Log.d("touch = ", " ************ Remove ALL ************************************ ");
                if (knownIds.size() > 1) {
                    last = current;
                    last.color = Color.GRAY;
                }
                current = new MyPolygon();
                knownIds = new ArrayList<Integer>();
            }

        invalidate();
        return true;

    }


    /**
     *
     * seuls deux polygones peuvent être dessinés : celui en cours de dessin (en noir) et
     * le précédent (en gris).
     * si on ne dessine plus, il n'y en a qu'un, en gris
     */
    public void onDraw(Canvas g) {
        super.onDraw(g);
        if (last != null) {
            paint.setColor(last.color);
            float [] pts = last.getPoints();
            if (pts != null) draw(g, pts, false);
        }
        if (current != null) {
            paint.setColor(current.color);
            float [] pts = current.getPoints();
            if (pts != null) draw(g, pts, false);
        }
    }



    private void draw(Canvas g, float[] pts, boolean closing)
    {
        for(int i = 0; i<pts.length-3; i=i+2)
        {
            g.drawLine(pts[i], pts[i+1], pts[i+2], pts[i+3], paint);
        } // ligne entre le dernier sommet et le premier somment g.drawLine(pts[pts.length-2], pts[pts.length-1], pts[0], pts[1], paint);
        if (closing) g.drawLine(pts[pts.length-2], pts[pts.length-1], pts[0], pts[1], paint);
    }


}
